{% extends "layout.html" %}
{% block content %}

<div class="container-fluid" id="graphs-top_container">
  <div class="row">
    {% for ID in ids %}
    <div class="col">
      <div class="card mx-auto my-3 carte" id="card_{{ ID }}">
        <div class="card-header">
          <div class="d-flex justify-content-between">
            <h5 id="title">{{ ID }} </h5>
            <a href="{{ url_for('timeView',ID= ID ) }}" target="_blank" class="material-icons"> history </a>
            <a href="{{ url_for('single_view',ID= ID ) }}" target="_blank" class="material-icons"> open_in_new</a>
            <span class="font-italic text-muted" id="updatetime_{{ ID }}">Loading...</span>
          </div>
        </div>
        <div class="m-auto graphique" id="graph_{{ ID }}">
        </div>
        <div class="card-body">
          <input class="tagsContainer" id="tags_{{ ID }}">
          </input>
          <div class="my-2" id="automatic_tags_{{ ID }}">
          </div>
        </div>
      </div>

    </div>
    {% if loop.index is even %}
    <div class="w-100"></div>
    {% endif %}
    {% endfor %}
  </div>
</div>

<script>
  $(function () {
    {% for ID in ids %}
    $("#tags_{{ ID }}").jsonTagEditor({
      initialTags: {{ tagsByID[ID] | safe }},
    delimiter: ' ', /* space and comma */
    placeholder: 'Add tags ...',
    clickDelete: true,
    animateDelete: 50,
    noSelect: true,
    beforeTagSave: function (field, editor, tags, tag, val) {
      if (tag === "") {

        $.ajax({
          url: "{{ url_for('addTag') }}",
          type: "GET",
          contentType: 'application/json;charset=UTF-8',
          data: {
            'tag': "{{ ID }}," + val
          },
          dataType: "json",
          success: function (data) {
            if (!data) {
              $("#tags_selection").append(new Option(val, val));
              //console.log("Le tag " + val + " a été ajouté dans la liste déroulante ");
            }
          }
        });
      }

      else {
        //console.log("Le tag a été changé")
        $.ajax({
          url: "{{ url_for('renameTag') }}",
          type: "GET",
          contentType: 'application/json;charset=UTF-8',
          data: {
            'tag': "{{ ID }}," + tag + "," + val
          },
          dataType: "json",
          success: function (data) {

            

            if (data.oldtagexists === "false") {

              $("#tags_selection option[value=" + tag + "]").remove();
              //console.log("Le tag" + tag + "a été enlevé de la liste déroulante")


            }
            if (data.newtagexists === "false") {
              $("#tags_selection").append(new Option(val, val));
              //console.log("Le tag " + val + " a été ajouté dans la liste déroulante ");
            }

          },
          error: function () {
            //console.log("Erreur")
          }
        });

      }
    },
    beforeTagDelete: function (field, editor, tags, val) {
      //console.log("Le tag " + val + " a été supprimé ");
      $.ajax({
        url: "{{ url_for('removeTag') }}",
        type: "GET",
        contentType: 'application/json;charset=UTF-8',
        data: {
          'tag': "{{ ID }}," + val
        },
        dataType: "json",
        success: function (data) {
          if (!data) {
            $("#tags_selection option[value=" + val + "]").remove();
            //console.log("Le tag a été enlevé de la liste déroulante")
          }
        }
      });
    }
        });
  {% endfor %}
    });
</script>

{% if ids %}
<script>
  var updateTime = 3000;
  $(document).ready(function () {
  {% for ID in ids %}
  $.ajax({
    url: "{{ url_for('lastHistogram') }}",
    type: "GET",
    contentType: 'application/json;charset=UTF-8',
    data: {
      'ID': "{{ ID }}"
    },
    dataType: "json",
    success: function (data) {
      Plotly.react("graph_{{ ID }}", data.figure);
      var time = moment(data.time * 1000).format('h:mm:ss a (MM/DD/YY)');
      $('#updatetime_{{ ID }}').text("Updated at " + time);
    }
  });
  {% endfor %}

  window.setInterval(function () {

    {% for ID in ids %}
    $.ajax({
      url: "{{ url_for('lastHistogram') }}",
      type: "GET",
      contentType: 'application/json;charset=UTF-8',
      data: {
        'ID': "{{ ID }}"
      },
      dataType: "json",
      success: function (data) {
        Plotly.react("graph_{{ ID }}", data.figure);
        var time = moment(data.time * 1000).format('h:mm:ss a (MM/DD/YY)');
        $('#updatetime_{{ ID }}').text("Updated at " + time);
      }
    });
    {% endfor %}
    }, 3000);
  });
</script>

{% endif %}

{% if not ids %}
<h3 class="my-4" style="text-align: center;"> No histograms to display! </h3>
{% endif %}

{% endblock %}